//----------------------------------------------------------------------------
// Borland BIDS Container Library Compatibility header
// Copyright (c) 1998, Yura Bidus, All Rights Reserved
//
//$Revision:   1.1  $
//
//----------------------------------------------------------------------------
#if !defined(CLASSLIB_DEFS_H)
#define CLASSLIB_DEFS_H

// nothind
#pragma message ("Included obsolete <classlib/defs.h>")

#if !defined(__cplusplus)
# error Must compile Borland Class Library as C++
#endif

#if !defined(OWL_DEFS_H)
# include <owl/defs.h>
#endif

//----------------------------------------------------------------------------
// We must use all libraries in DLLs if we are using BIDS in a DLL
//
// Define _BIDSDLL with -WSE (-WE for 32bit) to use BIDS & RTL in dlls.
//
// Be sure _BUILDBIDSDLL is defined when building an actual BIDS dll
//
#if defined(_BIDSDLL) || defined(_CLASSDLL) || defined(_BUILDBIDSDLL) || defined(_RTLDLL)
# if !defined(_BIDSDLL)
#   define _BIDSDLL
# endif
# if !defined(_SVCSDLL)
#   define _SVCSDLL
# endif
# if !defined(_RTLDLL)
#   define _RTLDLL
# endif
#endif

//----------------------------------------------------------------------------
//
//  To restore the old BIDS naming convention of data and function names
//  beginning with lowercase letters, in addition to the new convention of
//  uppercase letters, remove the // from the #define below or define on the
//  cmd line. The libraries do not need to be rebuilt.
//

//#define BI_OLDNAMES         // add names with initial lowercase

//----------------------------------------------------------------------------
//
//  Common definitions for pointer size and calling conventions.
//
//  Calling conventions:
//
//  _BIDSENTRY      Specifies the calling convention used by BIDS.
//
//
//  Export (and size for DOS) information:
//
//  _BIDSCLASS      Exports class if building DLL version of library.
//                  For DOS16 also provides size information.
//
//  _BIDSDATA       Exports data if building DLL version of library.
//
//  _BIDSFUNC       Exports function if building DLL version of library.
//                  For DOS16 also provides size information
//
//  _BIDSFAR        Promotes data pointers to far in DLLs (DOS16 only).
//
//  _BIDSFARDATA    Forces data pointer to be far.
//
//  _BIDSFARFUNC    Forces function to be far.
//
//  _BIDSFARCLASS   Forces class to be far.
//
//  _BIDSNEARDATA   Forces data to be near.
//
//  _BIDSNEARFUNC   Forces function to be near.
//
//  _BIDSNEARCLASS  Forces class to be near.
//
//----------------------------------------------------------------------------

#define _BIDSENTRY 			_OWLENTRY
#define _BIDSCTOR 			_OWLCTOR
#define _BIDSCLASS     	_OWLCLASS             // _export/import _CALLCNVN
#define _BIDSCLASS_RTL 	_OWLCLASS_RTL         // _export/import
#define _BIDSTEMPL     	_OWLCLASS_RTL         // _export/import
#define _BIDSDATA       _OWLCLASS_RTL         // _export/import
#define _BIDSFUNC      	_OWLCLASS_RTL         // _export/import

#if defined(BI_PLAT_WIN32)
# define _BIDSFARDATA
# define _BIDSFARFUNC
# define _BIDSFARCLASS
# define _BIDSNEARDATA
# define _BIDSNEARFUNC
# define _BIDSNEARCLASS
#else  // 16bit
# define _BIDSFARDATA     __far
# define _BIDSFARFUNC     __far
# define _BIDSFARCLASS    __far _CALLCNVN
# define _BIDSNEARDATA    __near
# define _BIDSNEARFUNC    __near
# define _BIDSNEARCLASS   __near _CALLCNVN
# define _BIDSDATA
#endif
#define _BIDSFAR

#endif  // CLASSLIB_DEFS_H
